# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from serv.settings import BASIS_PROC_DIR
from version import version

import os

import json

# Create your views here.

def json_emStat_show_builder(filesPath):
    jsonResult = '['
    i = 1

    while i <= 16:
        tmpFileName = 'tmp_emstat_' + i.__str__()
        os.system('cat ' + filesPath + 'em' + i.__str__() + ' > ./' + tmpFileName)
        # file = open(filesPath + 'em' + i.__str__(), 'r')
        file = open('./' + tmpFileName)
        fileTxt = file.read()
        divided = fileTxt.split('\n')

        file.close()
        os.system('rm ./' + tmpFileName)

        jsonStr = '{"EMAC_ID": ' + i.__str__() + ','

        is_first = True
        try:
            for line in divided[1:-1]:
                if line[0:4] == '    ':
                    jsonStr += '"' + line[4:] + '", '
                else:
                    if not is_first:
                        jsonStr = jsonStr[:-2] + '],'
                    else:
                        is_first = False
                    jsonStr += '"' + line[2:] + '": ['

            jsonStr = jsonStr[:-2] + ']}'
            jsonResult += jsonStr + ', '
            i += 1
        except IndexError:
            pass

    jsonResult = jsonResult[:-2] + ']'
    return jsonResult

@login_required
def estatApi(request):
    if request.method == 'GET':
        response = json_emStat_show_builder(BASIS_PROC_DIR + '/statistics/')
        return HttpResponse(response, content_type='application/json')
    else:
        emacObj = json.loads(request.body)
        if 'EMAC_ID' in emacObj:
            file = open(BASIS_PROC_DIR + '/statistics/em' + emacObj['EMAC_ID'], 'w')
            file.write('1')
            file.close()
        else:
            i = 1
            while i <= 16:
                file = open(BASIS_PROC_DIR + '/statistics/em' + i.__str__(), 'w')
                file.write('1')
                file.close()
                i += 1
    return HttpResponse('{"error": "No error"}')

@login_required
def estat_page(request):
    return render(request, 'emStat.html', { 'version': version })