# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render

from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from version import version
from serv.settings import BASIS_PROC_DIR

import json


# Create your views here.

def json_shaper_settings_builder(filesPath):
    jsonResult = '['
    i = 1

    while i <= 16:
        j = 1
        jsonStr = '{"PORT_ID": ' + i.__str__() + ', '
        jsonStr += '"settings": ['

        while j <= 4:
            file = open(filesPath + 'port' + i.__str__() + '_shapers', 'w')
            file.write('Shaper: ' + j.__str__() + '\n\n')
            file.close()

            file = open(filesPath + 'port' + i.__str__() + '_shapers', 'r')
            fileTxt = file.read()
            divided = fileTxt.split('\n')

            file.close()

            jsonStr += '{'

            for line in divided:
                splited = line.split('#', 1)[0]
                splited = splited.rsplit(':', 1)

                try:
                    if splited[1][-1] == ' ' or splited[1][-1] == '\t':
                        splited[1] = splited[1][:-1]
                except:
                    pass
                try:
                    jsonStr += '"' + splited[0] + '"' + ': ' + '"' + splited[1][1:] + '", '
                except IndexError:
                    file.close()
                    break
            jsonStr = jsonStr[:-2] + '}, '
            j += 1

        jsonStr = jsonStr[:-2] + ']}'
        jsonResult += jsonStr + ', '
        i += 1

    jsonResult = '[]' if jsonResult == '' else jsonResult[:-2] + ']'
    return jsonResult


@login_required
def shaper_sett_Api(request):
    if request.method == 'GET':
        response = json_shaper_settings_builder(BASIS_PROC_DIR + '/shaper_settings/')
        return HttpResponse(response, content_type='application/json')
    else:
        if request.method == 'POST':
            portSettObj = json.loads(request.body)
            print(portSettObj)
            mask = 'Shaper: {}\n' \
                   'Rate units: {}\n' \
                   'Max credit: {}\n' \
                   'Min credit: {}\n' \
                   'Rate: {}\n' \
                   'Position: {}\n' \
                   'Mode: {}\n' \
                   'Enable: {}\n\n' \

            try:
                formatted = mask.format(
                    portSettObj['Shaper'],
                    portSettObj['Rate units'],
                    portSettObj['Max credit'],
                    portSettObj['Min credit'],
                    portSettObj['Rate'],
                    portSettObj['Position'],
                    portSettObj['Mode'],
                    portSettObj['Enable']
                )
                response = '{"error": "No error"}'
                macAddFd = open(BASIS_PROC_DIR + '/shaper_settings/port' + portSettObj['PORT_ID'].__str__() + '_shapers', 'w')
                macAddFd.write(formatted)
                macAddFd.close()
            except KeyError:
                response = '{"error": "All fields are required!"}'

            return HttpResponse(response, content_type='application/json')


@login_required
def shaper_sett_page(request):
    return render(request, 'shaperSettings.html', { 'version': version })
