import React from 'react';

import Arrow from '../arrow_down.png';


export default class Popup extends React.Component {

    handleOkClick = (e) => {
        console.log(this.props.target);
        this.props.onDelete(true, this.props.target);
    };

    handleDislineClick = (e) => {
        this.props.onDelete(false);
    };


    render() {

        return (
            <div style={{
                'position': 'fixed',
                'left': '0',
                'top': '0',
                'bottom': '0',
                'right': '0',
                'background': 'rgba(255, 255, 255, 0.3)'
            }}>
                <div style={{
                    'position': 'fixed',
                    'left': '50%',
                    'top': '50%',
                    'transform': 'translate(-50%, -50%)',
                    'width': '300px',
                    'height': '120px',
                    'background': '#fff'
                }}>
                    <div style={{
                        'position': 'absolute',
                        'left': '50%',
                        'transform': 'translate(-50%, -50%)',
                        'top': '33%',
                        'textAlign': 'center',
                        'width': '100%'
                        // 'background': '#ccc'
                    }}>
                        { this.props.text }
                    </div>
                    <div style={{
                        'position': 'absolute',
                        'right': '25px',
                        'transform': 'translate(0, 50%)',
                        'bottom': '25%',
                        // 'background': '#08a801'
                    }}>
                        <button onClick={this.handleDislineClick} style={{
                            'background': '#fffffe',
                            'textAlign': 'center',
                            'fontSize': '14px',
                            'lineHeight': '14px',
                            'fontFamily': 'Montserrat',
                            'fontWeight': '300',
                            'margin': '0 4px 0 0'
                        }} autoFocus={true}> Cancel </button>
                        <button onClick={this.handleOkClick} style={{
                            'background': '#f33',
                            'textAlign': 'center',
                            'fontSize': '14px',
                            'lineHeight': '14px',
                            'fontFamily': 'Montserrat',
                            'fontWeight': '300'
                        }} autoFocus={true}> Delete </button>
                    </div>
                </div>
            </div>
        )
    }
}